package nl.vanhulzenonline.collections.filter
{
	import mx.collections.ArrayCollection;
	
	public class AndNode implements INode
	{
		public var left:INode;
		public var right:INode;
		
		public function AndNode(left:INode, right:INode)
		{
			this.left = left;
			this.right = right;
		}
		
		public function evaluate(data:ArrayCollection):Boolean
		{
			var result:Boolean = left.evaluate(data);
			if (result)
				return right.evaluate(data);
			return false;
		}
		
		public function toString():String
		{
			var result:String = "";
			if (left && right)
				result += "(";
			if (left)
				result += left.toString();
			if (left && right)
				result += " AND ";
			if (right)
				result += right.toString();
			if (left && right)
				result += ")";				
			return result;
		}
	}
}